#!/bin/sh

## Slackware build script for PostgreSQL
## $Revision: 5ad45bfd049c $
## $Date: 2011/09/27 08:41:46 $
##
## Copyright 2007-2011 Adis Nezirovic <adis _at_ linux.org.ba>
## Licensed under GNU GPL v2

# Modified by the SlackBuilds.org Project

PRGNAM=postgresql
VERSION=${VERSION:-9.1.4}
BUILD=${BUILD:-1}
TAG=${TAG:-"$(ls /var/log/packages/|grep vlconfig2|cut -d "-" -f4|cut -c 2-5)"}
LINK=${LINK:-"ftp://ftp.postgresql.org/pub/source/v${VERSION}/${PRGNAM}-${VERSION}.tar.bz2"}



if [ "$NORUN" != 1 ]; then

PG_UID=${PG_UID:-209}
PG_GID=${PG_GID:-209}

if [ -z "$ARCH" ]; then
  case "$( uname -m )" in
    i?86) ARCH=i586 ;;
    arm*) ARCH=arm ;;
       *) ARCH=$( uname -m ) ;;
  esac
fi

CWD=$(pwd)
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-${CWD}/..}


# DOWNLOAD SOURCE
for source in $(echo $LINK); do
	(
	cd $CWD
	wget -c --no-check-certificate $source
	)
done

# Bail out if user or group isn't valid on your system
# For slackbuilds.org, assigned postgres uid/gid are 209/209
# See http://slackbuilds.org/uid_gid.txt
# Other popular choice is 26/26
if ! grep ^postgres: /etc/group 2>&1 > /dev/null; then
  echo "  You must have a postgres group to run this script."
  echo "  Group will be created in 30 seconds"
  sleep 30
  groupadd -g $PG_GID postgres || exit 1
fi
if ! grep ^postgres: /etc/passwd 2>&1 > /dev/null; then
  echo "  You must have a postgres user to run this script."
  echo "  User will be created in 30 seconds"
  sleep 30
  useradd -u $PG_UID -g $PG_GID -d /var/lib/pgsql postgres || exit 1
fi


if [ "$ARCH" = "i?86" ]; then
  SLKCFLAGS="-O2 -march=i586 -mtune=i686"
  LIBDIRSUFFIX=""
elif [ "$ARCH" = "x86_64" ]; then
  SLKCFLAGS="-O2 -fPIC"
  LIBDIRSUFFIX="64"
else
  SLKCFLAGS="-O2"
  LIBDIRSUFFIX=""
fi

set -e

rm -rf $TMP/$PRGNAM-$VERSION $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
tar xvf $CWD/$PRGNAM-$VERSION.tar.bz2
cd $PRGNAM-$VERSION
chown -R root:root .
chmod -R a-s,u+w,go+r-w .

CFLAGS="$SLKCFLAGS" \
./configure \
  --prefix=/usr \
  --libdir=/usr/lib${LIBDIRSUFFIX} \
  --sysconfdir=/etc \
  --mandir=/usr/man \
  --docdir=/usr/doc/$PRGNAM-$VERSION \
  --with-openssl \
  --with-tcl \
  --with-perl \
  --with-python \
  --with-ldap \
  --with-libxml \
  --with-libxslt \
  --enable-thread-safety \
  --build=$ARCH-slackware-linux

make
make install-strip DESTDIR=$PKG
make install-docs DESTDIR=$PKG


# Some interesting additional modules:
#   http://www.postgresql.org/docs/9.0/static/contrib.html
#
#  adminpack - helper extension for pgAdmin
#  pgcrypto - extension for some business applications
#  hstore, ltree, xml2 - useful extensions for developers
#  pg_archivecleanup, pg_standby - high availability helpers
#  pg_upgrade - online upgrade between postgresql versions

PG_EXTENSIONS="adminpack pgcrypto hstore ltree xml2 pg_archivecleanup pg_standby pg_upgrade"

for ext in $PG_EXTENSIONS; do
  cd $TMP/$PRGNAM-$VERSION/contrib/$ext
  make
  make install-strip DESTDIR=$PKG
done

cd $TMP/$PRGNAM-$VERSION

find $PKG/usr/man -type f -exec gzip -9 {} \;
for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done

cp -a COPYRIGHT HISTORY README doc/KNOWN_BUGS doc/MISSING_FEATURES doc/TODO $PKG/usr/doc/$PRGNAM-$VERSION/
rm -rf $PKG/usr/doc/$PRGNAM-$VERSION/{man.tar.gz,man1,manl,man7,postgres.tar.gz}
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
cat $CWD/README.SBo > $PKG/usr/doc/$PRGNAM-$VERSION/README.SBo

# base database directory
# assumes you are using /var/lib/pgsql as a homedir for postgres user
mkdir -p $PKG/var/lib/pgsql/data
chown -R postgres:postgres $PKG/var/lib/pgsql
chmod 700 $PKG/var/lib/pgsql
# permissions for DATADIR should be u=rwx (0700)
chmod 700 $PKG/var/lib/pgsql/data

# Install init script
mkdir -p $PKG/etc/rc.d
cat $CWD/rc.postgresql.new > $PKG/etc/rc.d/rc.postgresql.new
chmod 0755 $PKG/etc/rc.d/rc.postgresql.new

# Install logrotate script
mkdir -p $PKG/etc/logrotate.d
cat $CWD/postgresql.logrotate > $PKG/etc/logrotate.d/postgresql.new

mkdir -p $PKG/var/log/setup
sed -e "s%@UID@%$PG_UID%" -e "s%@GID@%$PG_GID%" $CWD/setup.$PRGNAM \
  > $PKG/var/log/setup/setup.$PRGNAM
chmod 755 $PKG/var/log/setup/setup.$PRGNAM

mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/slack-desc > $OUTPUT/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh

cd $PKG
echo "Finding dependencies..."
ADD="$ADDRB" EXCLUDE="$EXRB" requiredbuilder -v -y -s $OUTPUT $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-txz}
fi
